/*
 * $Id: hash.h 1 2007-10-04 08:21:50Z rea $
 *
 * Copyright 2003-2007 Eygene A. Ryabinkin. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY EYGENE A. RYABINKIN "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EYGENE A. RYABINKIN OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __HASH_H__
#define __HASH_H__

#ifndef NULL
#define NULL ((void*)0)
#endif

typedef struct HASH_ENTRY {
	long n;
	char* key;
	struct HASH_ENTRY * next;
}HASH_ENTRY,*HASH_ENTRY_PTR;

typedef struct HASH {
	long size;             /* Hash size. */
	long free;             /* Next free hash position. */
	void** elements;       /* Array of hash elements - they are pointers. */
	HASH_ENTRY_PTR* hentry; /* Array of hash keys. */ 
}HASH,*HASH_PTR;

int CreateHash(HASH_PTR,long);
void DeleteHash(HASH_PTR);
long InHash(HASH_PTR,char*);
void* GetHashEntry(HASH_PTR,char*);
int ToHash(HASH_PTR,char*,void*);

#endif
