#!/usr/bin/perl -w

use POSIX qw(strftime);

my ($MIRROR,$MBOX,$dir,$date);
my (@MDirFiles,@SubDirs);

$MIRROR="/var/spool/mirror";
$MBOX="/var/mail/mailmirror";
$USER=".*";
$TODAY="NO";
$date=".*";
@SubDirs=("/In","/Out");

while( ($_ = $ARGV[0]) && /^-/ ) {
	shift @ARGV;
	last if /^--$/;
	if( /^-d/ ) {
		$date=$ARGV[0];
		if( !($date =~ /^\d\d\.\d\d\.\d\d\d\d$/) ) {
			die "Wrong date format: $date.\n";
		}
		shift @ARGV;
	}
	elsif( /^-f/ ) {
		$MBOX=$ARGV[0];
		shift @ARGV;
	}
	elsif( /^-u/ ) {
		$USER=$ARGV[0];
		shift @ARGV;
	}
	elsif( /^-t/ ) {
		$TODAY="YES";
	}
	elsif( /^-i/ ) {
		@SubDirs=("/In");
	}
	elsif( /^-o/ ) {
		@SubDirs=("/Out");
	}
}

if( $TODAY eq "YES" ) {
	$date=strftime "%d.%m.%Y",localtime;
}
$date=$date."_\\d+";

open MB,">>$MBOX" || die "Cannot create/rewrite $MBOX: $!";

foreach $i (@SubDirs) {
	$CURDIR=$MIRROR.$i;
	opendir(MDIR,$CURDIR) || die "Cannot open directory $CURDIR: $!";
	@MDirFiles=grep { /^[^\.]/ && /^$USER$/i && -d "$CURDIR/$_" } readdir(MDIR);
	closedir(MDIR);
	foreach $dir (@MDirFiles) {
		dumpdir("$CURDIR/$dir",$date,\*MB);
	}
}
close MB;
exit;

sub dumpdir {
	my $dir=shift;
	my $wcard=shift;
	my $fh=shift;
	my ($file,$date,$from,@files);
	print "Processing $dir\n";
	opendir(DIR,$dir) || return;
	@files=grep { /^[^\.]/ && /^$wcard$/ && -f "$dir/$_" } readdir(DIR);
	close(DIR);
	foreach $file (@files) {
		open FILE,"<$dir/$file" || die "Cannot open file $dir/$file: $!";
		$from="unknown";
		$date="Thu Jan 01 00:00:00 2000";
		HEADER: while( $_=<FILE> ) {
			chomp;
			if( /^From: (.*)$/ ) {
				$_=$1;
				/([^ @<]*@[^ >]*)/;
				$from="From $1";
			}
			elsif( /^Date: (\w\w\w), (\d\d) (\w\w\w) (\d\d\d\d) (\d\d:\d\d:\d\d).*$/ ) {
				$date="$1 $3 $2 $5 $4";
			}
			elsif( /^$/ ) {
				last HEADER;
			}
		}
		$from="$from $date";
		seek FILE,0,0;
		print $fh $from."\n";
		while( $_=<FILE> ) {
			s/\0x13\0x10$/0x10/;
			print $fh $_;
		}
		close FILE;
		print $fh "\n";
	}
	return;
}
